'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Spinner = require('./Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ItemList = function ItemList(_ref) {
  var items = _ref.items,
      selectItem = _ref.selectItem;
  return _react2.default.createElement(
    'ul',
    { className: 'item-list' },
    items.map(function (item) {
      return _react2.default.createElement(
        'li',
        {
          key: item.id,
          className: 'item-list--item',
          onClick: selectItem.bind(undefined, item) },
        item.loading && _react2.default.createElement(_Spinner2.default, null),
        item.title
      );
    })
  );
};

ItemList.defaultProps = {
  items: [],
  selectItem: function selectItem() {},
  loading: false
};

exports.default = ItemList;