"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactTransitionGroup = require("react-transition-group");

var _Spinner = require("./Spinner");

var _Spinner2 = _interopRequireDefault(_Spinner);

var _ItemList = require("./ItemList");

var _ItemList2 = _interopRequireDefault(_ItemList);

var _NestedDropdownHeader = require("./NestedDropdownHeader");

var _NestedDropdownHeader2 = _interopRequireDefault(_NestedDropdownHeader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NestedDropdown = function (_React$Component) {
  _inherits(NestedDropdown, _React$Component);

  function NestedDropdown(props) {
    _classCallCheck(this, NestedDropdown);

    var _this = _possibleConstructorReturn(this, (NestedDropdown.__proto__ || Object.getPrototypeOf(NestedDropdown)).call(this, props));

    _this.state = {
      nextItems: false
    };
    return _this;
  }

  _createClass(NestedDropdown, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var direction = void 0;
      if (nextProps.direction) {
        direction = nextProps.direction;
        this.setState({
          nextItems: nextProps.items,
          forward: nextProps.direction === 'forward',
          backward: nextProps.direction === 'backward'
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      if (this.props.items.length === 0) {
        return _react2.default.createElement(_Spinner2.default, null);
      }

      var items = [_react2.default.createElement(_ItemList2.default, {
        key: this.props.items[0].title,
        items: this.props.items,
        selectItem: this.props.selectItem
      })];

      // we need some way to key the list so react knows which is entering/leaving
      // since example data uses id [0...10] for each list, it is repeated
      // thus we use the title as the identifier

      if (this.state.forward) {
        items = items.concat(_react2.default.createElement(_ItemList2.default, {
          key: this.state.nextItems[0].title,
          items: this.state.nextItems,
          selectItem: this.props.selectItem
        }));
        items.splice(0, 1);
      }

      if (this.state.backward) {
        items.unshift(_react2.default.createElement(_ItemList2.default, {
          key: this.state.nextItems[0].title,
          items: this.state.nextItems,
          selectItem: this.props.selectItem
        }));
        items.splice(0, 1);
      }

      return _react2.default.createElement(
        "div",
        {
          className: "nested-dropdown",
          style: { width: this.props.width, position: 'relative', overflow: this.props.loading ? 'hidden' : 'scroll' } },
        _react2.default.createElement(_NestedDropdownHeader2.default, {
          back: this.props.handleBack,
          isRoot: this.props.isRoot,
          loading: this.props.loading
        }),
        _react2.default.createElement(
          "div",
          { className: "viewport" },
          _react2.default.createElement(
            _reactTransitionGroup.CSSTransitionGroup,
            {
              component: "div",
              className: "animated-list",
              transitionName: this.state.forward ? 'forward' : 'backward',
              transitionEnterTimeout: 1000,
              transitionLeaveTimeout: 1000 },
            items
          )
        )
      );
    }
  }]);

  return NestedDropdown;
}(_react2.default.Component);

NestedDropdown.defaultProps = {
  items: [],
  forward: false,
  backward: false,
  loading: false
};

exports.default = NestedDropdown;