"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fakePromise = exports.fakeCompanies = undefined;

var _faker = require("faker");

var _faker2 = _interopRequireDefault(_faker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fakeCompanies = exports.fakeCompanies = function fakeCompanies(size) {
  return function () {
    return new Array(size).fill('').map(function () {
      return {
        id: Math.random(),
        title: _faker2.default.company.companyName()
      };
    });
  };
};

var fakePromise = exports.fakePromise = function fakePromise(func) {
  var time = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 200;

  return new Promise(function (resolve, reject) {
    setTimeout(function () {
      resolve(func.call(undefined));
    }, time);
  });
};